var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: !0 });
import { FUniver, ICommandService } from "@univerjs/core";
import { EnableCrosshairHighlightOperation, DisableCrosshairHighlightOperation, SetCrosshairHighlightColorOperation, SheetsCrosshairHighlightService, CROSSHAIR_HIGHLIGHT_COLORS } from "@univerjs/sheets-crosshair-highlight";
const _FUniverCrosshairHighlightMixin = class _FUniverCrosshairHighlightMixin extends FUniver {
  /**
   * @ignore
   */
  _initialize(injector) {
    const commandService = injector.get(ICommandService);
    this.disposeWithMe(commandService.onCommandExecuted((commandInfo) => {
      if (commandInfo.id === EnableCrosshairHighlightOperation.id || commandInfo.id === DisableCrosshairHighlightOperation.id) {
        const activeSheet = this.getActiveSheet();
        if (!activeSheet || !this._eventListend(this.Event.CrosshairHighlightEnabledChanged)) return;
        this.fireEvent(this.Event.CrosshairHighlightEnabledChanged, {
          enabled: this.getCrosshairHighlightEnabled(),
          ...activeSheet
        });
      }
      if (commandInfo.id === SetCrosshairHighlightColorOperation.id) {
        const activeSheet = this.getActiveSheet();
        if (!activeSheet || !this._eventListend(this.Event.CrosshairHighlightColorChanged)) return;
        this.fireEvent(this.Event.CrosshairHighlightColorChanged, {
          color: this.getCrosshairHighlightColor(),
          ...activeSheet
        });
      }
    }));
  }
  setCrosshairHighlightEnabled(enabled) {
    return enabled ? this._commandService.syncExecuteCommand(EnableCrosshairHighlightOperation.id) : this._commandService.syncExecuteCommand(DisableCrosshairHighlightOperation.id), this;
  }
  setCrosshairHighlightColor(color) {
    return this._commandService.syncExecuteCommand(SetCrosshairHighlightColorOperation.id, {
      value: color
    }), this;
  }
  getCrosshairHighlightEnabled() {
    return this._injector.get(SheetsCrosshairHighlightService).enabled;
  }
  getCrosshairHighlightColor() {
    return this._injector.get(SheetsCrosshairHighlightService).color;
  }
  get CROSSHAIR_HIGHLIGHT_COLORS() {
    return CROSSHAIR_HIGHLIGHT_COLORS;
  }
};
__name(_FUniverCrosshairHighlightMixin, "FUniverCrosshairHighlightMixin");
let FUniverCrosshairHighlightMixin = _FUniverCrosshairHighlightMixin;
FUniver.extend(FUniverCrosshairHighlightMixin);
